#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "suffix"
const int MaxN = 100005;

char s [MaxN];
char v [MaxN];
int p [MaxN];
int n;

int main (void)
{
 int i, j, k;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %s", s) != EOF)
 {
  n = strlen (s);
  assert (1 <= n && n <= 100000);
  j = 0;
  v[j] = s[0];
  k = -1;
  p[j] = k;
  j++;
  for (i = 1; i < n; i++)
  {
   while (k >= 0 && s[i] != v[k + 1])
   {
    if (s[i] < v[k + 1])
     j = k + 1;
    k = p[k];
   }
   if (s[i] < v[k + 1])
    j = 0;
   else if (s[i] == v[k + 1])
    k++;
   v[j] = s[i];
   p[j] = k;
   j++;
/*
   int z;
   printf ("%d %d %d\n", i, j, k);
   for (z = 0; z <= i; z++)
    printf ("%3c%c", s[z], z + 1 <= i ? ' ' : '\n');
   for (z = 0; z < j; z++)
    printf ("%3c%c", v[z], z + 1 < j ? ' ' : '\n');
   for (z = 0; z < j; z++)
    printf ("%3d%c", p[z], z + 1 < j ? ' ' : '\n');
*/
  }
  k = j - 1;
  while (k >= 0)
  {
   j = k + 1;
   k = p[k];
  }
  v[j] = '\0';
  printf ("%s\n", v);
 }
 return 0;
}
